#include <iostream>
#include <vector>

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

using namespace std;

int main()
{
    size_t number_count, bin_count, max_count;

    cerr << "Enter number count: ";
    cin >> number_count;

    vector<double> numbers(number_count);

    cerr << "Enter numbers: ";
    for (size_t i = 0; i < number_count; i++){
        cin >> numbers[i];
    }

    cerr << "Enter bin count: ";
    cin >> bin_count;





    double min = numbers[0];
    double max = numbers[0];

    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }

    /*

    for (size_t i = 0; i < number_count; i++) {

    }


    */

    vector<size_t> bins(bin_count);
    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++) {
        bool found = false; //    .     
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) { //  j- 
            auto lo = min + j * bin_size; //    
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) { //     i-   numbers
                bins[j]++; //       (),    j- 
                found = true; //  "",        . .  numbers
            }                 //             
        }
        if (!found) { //      .  ,   ,      
            bins[bin_count - 1]++; //   .   
        }
    }

    //      
    max_count = 0;
    for (size_t x: bins) {
        if (x > max_count) {
                max_count = x;
        }
    }

    if (max_count > MAX_ASTERISK) {
        for (size_t count: bins) {
            size_t height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
            if (count < 10) {
                cout << "  " << count << "|";
            }
            else if (count >= 100) {
                cout << count << "|";
            }

            else {
                cout << " " << count << "|";
            }

            for (size_t i = 0; i < height; i++) {
                cout << "*";
            }
            cout << "\n";
        }
    }

    else {
        for (size_t x: bins) {
            if (x < 10) {
                cout << "  " << x << "|";
            }
            else if (x >= 100) {
                cout << x << "|";
            }

            else {
                cout << " " << x << "|";
            }

            for (size_t i = 0; i < x; i++) {
                cout << "*";
            }
            cout << "\n";
        }
    }
    return 0;
}

